// IlscopeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Ilscope.h"
#include "IlscopeDlg.h"
#include "IlSetup.h"
#include "TcpIp.h"
#include "Mnemo.h"

#define VERSION   "1.56"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CIlscopeApp theApp;

#ifdef _DEBUG
LPCTSTR szNoTitle = _T("ILScope ")_T(VERSION)_T(" Debug");
#else
LPCTSTR szNoTitle = _T("ILScope ")_T(VERSION);
#endif

static const LPCTSTR szLicence =
	_T("This program is free software; you can redistribute it and/or modify\r\n")
	_T("it under the terms of the GNU General Public License as published by\r\n")
	_T("the Free Software Foundation; either version 2 of the License, or\r\n")
	_T("(at your option) any later version.\r\n")
	_T("\r\n")
	_T("This program is distributed in the hope that it will be useful,\r\n")
	_T("but WITHOUT ANY WARRANTY; without even the implied warranty of\r\n")
	_T("MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\r\n")
	_T("See the GNU General Public License for more details.\r\n")
	_T("\r\n")
	_T("You should have received a copy of the GNU General Public License along\r\n")
	_T("with this program; if not, write to the Free Software Foundation, Inc.,\r\n")
	_T("51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.");

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here
	SetDlgItemText(IDC_VERSION,szNoTitle);
	SetDlgItemText(IDC_LICENSE,szLicence);

	return TRUE;  // return TRUE unless you set the focus to a control
				  // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CIlscopeDlg dialog

CIlscopeDlg::CIlscopeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIlscopeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CIlscopeDlg)
	m_strScope = _T("");
	m_bScope = TRUE;						// enabled scope window
	m_bIDY = TRUE;							// show IDY frames
	m_bRFC = TRUE;							// show RFC frames
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_strAddrOut = _T("localhost");
	m_uPortOut   = 60000;
	m_uPortIn    = 60001;

	m_dwConnectTimeout = 0xFFFFFFFF;		// client connect timeout in us (default blocked connect timeout)

	m_pComObj = NULL;
	m_pMnemo = NULL;
}

CIlscopeDlg::~CIlscopeDlg()
{
	delete m_pMnemo;						// delete mnenomonic disassembler class
}

/////////////////////////////////////////////////////////////////////////////
// CIlscopeDlg settings helper functions

CString CIlscopeDlg::ReadString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszDefault)
{
	if (*theApp.m_szIniFile != 0)
	{
		TCHAR cBuffer[1024];

		::GetPrivateProfileString(lpszSection,lpszEntry,lpszDefault,cBuffer,ARRAYSIZEOF(cBuffer),theApp.m_szIniFile);
		return CString(cBuffer);
	}
	else
	{
		return AfxGetApp()->GetProfileString(lpszSection,lpszEntry,lpszDefault);
	}
}

UINT CIlscopeDlg::ReadInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nDefault)
{
	if (*theApp.m_szIniFile != 0)
	{
		return ::GetPrivateProfileInt(lpszSection,lpszEntry,nDefault,theApp.m_szIniFile);
	}
	else
	{
		return AfxGetApp()->GetProfileInt(lpszSection,lpszEntry,nDefault);
	}
}

BOOL CIlscopeDlg::WriteString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszValue)
{
	if (*theApp.m_szIniFile != 0)
	{
		return ::WritePrivateProfileString(lpszSection,lpszEntry,lpszValue,theApp.m_szIniFile);
	}
	else
	{
		return AfxGetApp()->WriteProfileString(lpszSection,lpszEntry,lpszValue);
	}
}

BOOL CIlscopeDlg::WriteInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nValue)
{
	if (*theApp.m_szIniFile != 0)
	{
		TCHAR s[16];
		wsprintf(s,_T("%u"),nValue);
		return ::WritePrivateProfileString(lpszSection,lpszEntry,s,theApp.m_szIniFile);
	}
	else
	{
		return AfxGetApp()->WriteProfileInt(lpszSection,lpszEntry,nValue);
	}
}

void CIlscopeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIlscopeDlg)
	DDX_Control(pDX, IDC_STOP, m_CButStop);
	DDX_Control(pDX, IDC_START, m_CButStart);
	DDX_Text(pDX, IDC_SCOPE, m_strScope);
	DDX_Check(pDX, IDC_SCOPE_EN, m_bScope);
	DDX_Check(pDX, IDC_RFC_EN, m_bRFC);
	DDX_Check(pDX, IDC_IDY_EN, m_bIDY);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CIlscopeDlg, CDialog)
	ON_MESSAGE(WM_INTERFACESTOPPED, OnInterfaceStopped)

	//{{AFX_MSG_MAP(CIlscopeDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_RFC_EN, OnRfcEn)
	ON_BN_CLICKED(IDC_SCOPE_EN, OnScopeEn)
	ON_BN_CLICKED(IDC_IDY_EN, OnIdyEn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIlscopeDlg message handlers

BOOL CIlscopeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "TCP/IP Setup...", "Help Topics..." and "About ILVideo..."
	// menu items to the system menu.

	// IDM_HPILSETUP must be in the system command range.
	ASSERT((IDM_HPILSETUP & 0xFFF0) == IDM_HPILSETUP);
	ASSERT(IDM_HPILSETUP < 0xF000);

	// IDM_HELPTOPICS must be in the system command range.
	ASSERT((IDM_HELPTOPICS & 0xFFF0) == IDM_HELPTOPICS);
	ASSERT(IDM_HELPTOPICS < 0xF000);

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strText;
		pSysMenu->AppendMenu(MF_SEPARATOR);

		strText.LoadString(IDS_TCPIP_SETTING);
		pSysMenu->AppendMenu(MF_STRING, IDM_HPILSETUP, strText);

		strText.LoadString(IDS_HELP_TOPICS);
		pSysMenu->AppendMenu(MF_STRING, IDM_HELPTOPICS, strText);

		strText.LoadString(IDS_ABOUTBOX);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strText);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//	when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE); 		// Set big icon
//	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_CButStart.EnableWindow(TRUE);
	m_CButStop.EnableWindow(FALSE);

	// subclass scope edit control for own context menu
	m_editScope.SubclassDlgItem(IDC_SCOPE,this);

	m_editScope.SetLimitText(0);			// increase edit box text size to maximum

	if (*theApp.m_szIniFile != 0)			// ini file given
	{
		CString strTitle,strAppTitle;

		// new document title
		GetWindowText(strAppTitle);
		strTitle.Format(_T("%s - %s"),strAppTitle,theApp.m_lpFilePart);
		SetWindowText(strTitle);			// set document title with ini file
	}

	// font settings
	SendDlgItemMessage(IDC_STATIC_HPIL_SCOPE,WM_SETFONT,(WPARAM)GetStockObject(DEFAULT_GUI_FONT),MAKELPARAM(FALSE,0));
	SendDlgItemMessage(IDC_START,			 WM_SETFONT,(WPARAM)GetStockObject(DEFAULT_GUI_FONT),MAKELPARAM(FALSE,0));
	SendDlgItemMessage(IDC_STOP,			 WM_SETFONT,(WPARAM)GetStockObject(DEFAULT_GUI_FONT),MAKELPARAM(FALSE,0));
	SendDlgItemMessage(IDC_SCOPE_EN,		 WM_SETFONT,(WPARAM)GetStockObject(DEFAULT_GUI_FONT),MAKELPARAM(FALSE,0));
	SendDlgItemMessage(IDC_IDY_EN,			 WM_SETFONT,(WPARAM)GetStockObject(DEFAULT_GUI_FONT),MAKELPARAM(FALSE,0));
	SendDlgItemMessage(IDC_RFC_EN,			 WM_SETFONT,(WPARAM)GetStockObject(DEFAULT_GUI_FONT),MAKELPARAM(FALSE,0));

	// get actual window position
	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(wndpl);
	GetWindowPlacement(&wndpl);

	// load positions from registry if available
	m_nPosX  = ReadInt(_T("Settings"),_T("WinPosX"),wndpl.rcNormalPosition.left);
	m_nPosY  = ReadInt(_T("Settings"),_T("WinPosY"),wndpl.rcNormalPosition.top);

	m_bScope = ReadInt(_T("Settings"),_T("Scope"),m_bScope);
	m_bIDY   = ReadInt(_T("Settings"),_T("EnableIDY"),m_bIDY);
	m_bRFC   = ReadInt(_T("Settings"),_T("EnableRFC"),m_bRFC);

	m_strAddrOut = ReadString(_T("Settings"),_T("AddrOut"),m_strAddrOut);
	m_uPortOut   = ReadInt(_T("Settings"),_T("PortOut"),m_uPortOut);
	m_uPortIn    = ReadInt(_T("Settings"),_T("PortIn"),m_uPortIn);
	m_dwConnectTimeout = ReadInt(_T("Settings"),_T("ConnectTimeout"),m_dwConnectTimeout);

	SetWindowLocation(m_nPosX,m_nPosY);		// set windows location

	m_pMnemo = new CMnemo(m_editScope,30,6); // the mnemonic disassembler

	// update scope settings
	m_pMnemo->EnableScope(m_bScope);
	m_pMnemo->EnableIDY(m_bIDY);
	m_pMnemo->EnableRFC(m_bRFC);

	UpdateData(FALSE);

	// press the "Start" button
	if (theApp.m_bStart) PostMessage(WM_COMMAND,IDC_START);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

BOOL CIlscopeDlg::PreTranslateMessage(MSG* pMsg)
{
	// TODO: Add your specialized code here and/or call the base class
	if (pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_ESCAPE)
	{
		return TRUE;  // disable the ESC key quitting the application
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CIlscopeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	switch (nID & 0xFFF0)
	{
	case IDM_HPILSETUP:
	{
		CILSetup dlg(m_strAddrOut,m_uPortOut,m_uPortIn);
		if (IDOK == dlg.DoModal())
		{
			dlg.GetData(m_strAddrOut,m_uPortOut,m_uPortIn);
		}
		break;
	}
	case IDM_HELPTOPICS:
		ShellExecute(GetSafeHwnd(),
					 _T("open"),
					 _T("ILScope.htm"),
					 NULL,
					 _T(""),
					 SW_SHOWNORMAL);
		break;
	case IDM_ABOUTBOX:
		CAboutDlg().DoModal();
		break;
	default:
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//	to draw the icon.  For MFC applications using the document/view model,
//	this is automatically done for you by the framework.

void CIlscopeDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//	the minimized window.
HCURSOR CIlscopeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// set window location
VOID CIlscopeDlg::SetWindowLocation(INT nPosX,INT nPosY)
{
	WINDOWPLACEMENT wndpl;
	RECT *pRc = &wndpl.rcNormalPosition;

	wndpl.length = sizeof(wndpl);
	GetWindowPlacement(&wndpl);
	pRc->right = pRc->right - pRc->left + nPosX;
	pRc->bottom = pRc->bottom - pRc->top + nPosY;
	pRc->left = nPosX;
	pRc->top = nPosY;
	SetWindowPlacement(&wndpl);
	return;
}

void CIlscopeDlg::OnScopeEn()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);						// update m_bScope variable
	m_pMnemo->EnableScope(m_bScope);
}

void CIlscopeDlg::OnIdyEn()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);						// update m_bIDY variable
	m_pMnemo->EnableIDY(m_bIDY);
}

void CIlscopeDlg::OnRfcEn()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);						// update m_bRFC variable
	m_pMnemo->EnableRFC(m_bRFC);
}

void CIlscopeDlg::OnStart()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	SetDlgItemText(IDC_SCOPE,_T(""));		// clear scope display

	m_pComObj = new CTcpIp(m_pMnemo,m_strAddrOut,m_uPortOut,m_uPortIn,m_dwConnectTimeout,this);
	if (m_pComObj != NULL)
	{
		if (m_pComObj->StartServer() == true) // init server
		{
			m_CButStart.SetButtonStyle(BS_PUSHBUTTON);
			m_CButStart.EnableWindow(FALSE);
			m_CButStop.EnableWindow(TRUE);
			m_CButStop.SetButtonStyle(BS_DEFPUSHBUTTON);
			m_CButStop.SetFocus();
		}
		else								// error
		{
			ASSERT(m_pComObj);				// free Interface class
			delete m_pComObj;
			m_pComObj = NULL;
		}
	}
}

void CIlscopeDlg::OnStop()
{
	// TODO: Add your control notification handler code here
	ASSERT(m_pComObj != NULL);
	m_pComObj->StopServer();				// quit server thread
}

LRESULT CIlscopeDlg::OnInterfaceStopped(WPARAM wParam,LPARAM lParam)
{
	// quit message from Interface worker thread
	CInterface *pComObj = reinterpret_cast<CInterface *>(wParam);
	ASSERT(pComObj == m_pComObj);

	ASSERT(m_pComObj);
	delete m_pComObj;
	m_pComObj = NULL;

	m_CButStop.SetButtonStyle(BS_PUSHBUTTON);
	m_CButStop.EnableWindow(FALSE);
	m_CButStart.EnableWindow(TRUE);
	m_CButStart.SetButtonStyle(BS_DEFPUSHBUTTON);
	m_CButStart.SetFocus();
	return 0;
	UNREFERENCED_PARAMETER(wParam);
	UNREFERENCED_PARAMETER(lParam);
}

void CIlscopeDlg::OnCancel()
{
	// TODO: Add extra cleanup here
	if (m_pComObj != NULL)					// Interface running
	{
		OnStop();
		PostMessage(WM_COMMAND,IDCANCEL,0); // call myself, until thread finished
		return;
	}

	// save current settings
	UpdateData(TRUE);

	// get actual window position
	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(wndpl);
	GetWindowPlacement(&wndpl);
	m_nPosX = wndpl.rcNormalPosition.left;
	m_nPosY = wndpl.rcNormalPosition.top;

	TCHAR szAppFile[_MAX_PATH];				// full pathname of application
	GetModuleFileName(NULL,szAppFile,ARRAYSIZEOF(szAppFile));
	WriteString(_T("Run"),_T("App"),szAppFile);

	WriteInt(_T("Settings"),_T("WinPosX"),m_nPosX);
	WriteInt(_T("Settings"),_T("WinPosY"),m_nPosY);
	WriteInt(_T("Settings"),_T("Scope"),m_bScope);
	WriteInt(_T("Settings"),_T("EnableIDY"),m_bIDY);
	WriteInt(_T("Settings"),_T("EnableRFC"),m_bRFC);
	WriteString(_T("Settings"),_T("AddrOut"),m_strAddrOut);
	WriteInt(_T("Settings"),_T("PortOut"),m_uPortOut);
	WriteInt(_T("Settings"),_T("PortIn"),m_uPortIn);
	WriteInt(_T("Settings"),_T("ConnectTimeout"),m_dwConnectTimeout);

	CDialog::OnCancel();
}
