// IlscopeDlg.h : header file
//

#if !defined(AFX_ILSCOPEDLG_H__9B9DEBFC_1E9F_4711_9E5A_F359A0FFC581__INCLUDED_)
#define AFX_ILSCOPEDLG_H__9B9DEBFC_1E9F_4711_9E5A_F359A0FFC581__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "EditCC.h"

class CIL;									// loop interface class
class CInterface;							// interface object class
class CMnemo;								// the IL scope

/////////////////////////////////////////////////////////////////////////////
// CIlscopeDlg dialog

class CIlscopeDlg : public CDialog
{
// Construction
public:
	CIlscopeDlg(CWnd* pParent = NULL);	// standard constructor
	virtual ~CIlscopeDlg();

// Dialog Data
	//{{AFX_DATA(CIlscopeDlg)
	enum { IDD = IDD_ILSCOPE_DIALOG };
	CButton	m_CButStop;
	CButton	m_CButStart;
	CString	m_strScope;
	BOOL	m_bScope;
	BOOL	m_bIDY;
	BOOL	m_bRFC;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CIlscopeDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	LRESULT OnInterfaceStopped(WPARAM wParam, LPARAM lParam);

	// Generated message map functions
	//{{AFX_MSG(CIlscopeDlg)
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnStart();
	afx_msg void OnStop();
	virtual void OnCancel();
	afx_msg void OnRfcEn();
	afx_msg void OnScopeEn();
	afx_msg void OnIdyEn();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	LONG    m_nPosX;						// display position
	LONG    m_nPosY;

	CString m_strAddrOut;
	UINT    m_uPortIn;
	UINT    m_uPortOut;
	DWORD   m_dwConnectTimeout;				// client connect timeout

	CEditCC m_editScope;					// edit controls with own context menu

	CInterface *m_pComObj;					// interface object class
	CMnemo     *m_pMnemo;					// the mnemonic disassembler

	CString ReadString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszDefault);
	UINT    ReadInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nDefault);
	BOOL    WriteString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszValue);
	BOOL    WriteInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nValue);

	VOID SetWindowLocation(INT nPosX, INT nPosY);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ILSCOPEDLG_H__9B9DEBFC_1E9F_4711_9E5A_F359A0FFC581__INCLUDED_)
